Foxit PDF SDK

Static Public Member Functions | List of all members
foxit::addon::optimization::Optimizer Class Reference
Inheritance diagram for foxit::addon::optimization::Optimizer:

## Static Public Member Functions
static AuditSpaceSize | ComputeAuditSpace (const pdf::PDFDoc &doc)
| Compute audit space. More...
static common::Progressive | Optimize (const pdf::PDFDoc &doc, const OptimizerSettings &settings, common::PauseCallback *pause)
| Optimize the given PDF document with specified optimizer settings. More...
static common::Progressive | OptimizeScannedPDF (const pdf::PDFDoc &doc, const OptimizeScannedPDFSettings &settings, ImageCompressionCallback *image_compress_callback, common::PauseCallback *pause)
| Optimize the scanned PDF document with specified optimizers settings. More...
static common::Progressive | StartSubsetEmbedFont (const pdf::PDFDoc &doc, common::PauseCallback *pause)
| Start to make subsets for embedded fonts in the given PDF document. More...

## Additional Inherited Members
Public Member Functions inherited from foxit::Base
FS_HANDLE | Handle () const
| Get the handle of current object. More...

## Detailed Description

This class can be used to optimize PDF file to reduce file size. Before using this class to do optimization, please ensure Foxit PDF SDK has been initialized successfully by function common::Library::Initialize with a key including "Optimizer" module.

See also
  common::Library

## Member Function Documentation

## ◆ ComputeAuditSpace()

static AuditSpaceSize foxit::addon::optimization::Optimizer::ComputeAuditSpace | ( | const pdf::PDFDoc & | doc | ) |
| static

Compute audit space.

Parameters

  [in] | doc | A valid PDF document object to audit space.

Returns
  A struct that contain all audit space contents.

## ◆ Optimize()

static common::Progressive foxit::addon::optimization::Optimizer::Optimize | ( | const pdf::PDFDoc & | doc,
|  | const OptimizerSettings & | settings,
|  | common::PauseCallback * | pause
| ) |  |
| static

Optimize the given PDF document with specified optimizer settings.

Parameters

  [in] | doc | A valid PDF document object to be optimized.
  [in] | settings | Setting data used for optimization processing settings.
  [in] | pause | Pause object which decides if the process needs to be paused. This can be NULL which means not to pause during the optimization process. If this is not NULL, it should be a valid pause object implemented by user.

Note
  If module "Optimizer" is not defined in the license information which is used in function common::Library::Initialize, that means user has no right in using Optimization related functions and this function will throw exception foxit::e_ErrNoOptimizerModuleRight.

Returns
  A progressive object. Please check the rate of current progress by function common::Progressive::GetRateOfProgress. If the rate is not 100 yet, call function common::Progressive::Continue to continue the progress until the progress is finished.

## ◆ OptimizeScannedPDF()

static common::Progressive foxit::addon::optimization::Optimizer::OptimizeScannedPDF | ( | const pdf::PDFDoc & | doc,
|  | const OptimizeScannedPDFSettings & | settings,
|  | ImageCompressionCallback * | image_compress_callback,
|  | common::PauseCallback * | pause
| ) |  |
| static

Optimize the scanned PDF document with specified optimizers settings.

Parameters

  [in] | doc | A valid PDF document object to be optimized.
  [in] | settings | Setting data used for optimization processing settings.
  [in] | image_compress_callback | A foxit::addon::optimization::ImageCompressionCallback object which is implemented by user for temp file data during replacing page process. When replacing pages process is finished (no matter successfully or not), callback function foxit::addon::optimization::ImageCompressionCallback::Release will be called by Foxit PDF SDK.
  [in] | pause | Pause object which decides if the process needs to be paused. This can be NULL which means not to pause during the optimization process. If this is not NULL, it should be a valid pause object implemented by user.

Note
  If module "Optimizer" is not defined in the license information which is used in function common::Library::Initialize, that means user has no right in using Optimization related functions and this function will throw exception foxit::e_ErrNoOptimizerModuleRight. If optimize the scanned pdf finished, the specify pages to be optimized needs to be reloaded.

Returns
  A progressive object. Please check the rate of current progress by function common::Progressive::GetRateOfProgress. If the rate is not 100 yet, call function common::Progressive::Continue to coninue the progress until the progress is finished.

## ◆ StartSubsetEmbedFont()

static common::Progressive foxit::addon::optimization::Optimizer::StartSubsetEmbedFont | ( | const pdf::PDFDoc & | doc,
|  | common::PauseCallback * | pause
| ) |  |
| static

Start to make subsets for embedded fonts in the given PDF document.

This function can be used to remove useless embedded characters from the data of embedded fonts (if there's any in a PDF document) in order to reduce the size of a PDF document.

Parameters

  [in] | doc | A valid PDF document object to be processed a subset of embedded fonts.
  [in] | pause | Pause object which decides if the process needs to be paused. This can be NULL which means not to pause during the embeded font subset process. If this is not NULL, it should be a valid pause object implemented by user.

Note
  If module "Optimizer" is not defined in the license information which is used in function common::Library::Initialize, that means user has no right in using Optimization related functions and this function will throw exception foxit::e_ErrNoOptimizerModuleRight.

Returns
  A progressive object. Please check the rate of current progress by function common::Progressive::GetRateOfProgress. If the rate is not 100 yet, call function common::Progressive::Continue to continue the progress until the progress is finished.